package types

import (
	"rs/cmd/api/internal/config"
	"rs/genModel"
	"rs/rpc/transferClient"
)

type BaseServiceContext struct {
	Config              config.Config
	TransferRpc         transferClient.Transfer // 调用transfer服务
	ProductRedirectConf genModel.ProductRedirectConfModel
	Merchant            genModel.MerchantModel
	TransferOrder       genModel.ServerOrderModel
	MerchantWechat      genModel.MerchantWechatModel
}

type DecryptReqData struct {
	SipOrderNo  string `json:"sipOrderNo"`
	VoucherTag  string `json:"voucherTag"`
	AccountType int32  `json:"accountType"`
	AccountNo   string `json:"accountNo"`
	AccountInfo string `json:"accountInfo,optional"`
	Num         int32  `json:"num"`
}

type NotifyTypes struct {
	Coupon string `json:"coupon_grant_order"`
	Grant  string `json:"wechat_coupon_status"`
}

type KeySendExtendParam struct {
	AppId    string `json:"appId"`
	PosId    string `json:"posId"`
	Num      int64  `json:"num"`
	MobileNo string `json:"mobileNo"`
	SendMsg  string `json:"sendMsg"`
}
